# python3 3sp.py -h            |    |    | esolangin' on the lone desert highway
import                  argparse    ;    #
def      parse_contents(contents    )    :
    instructions               =    [    ]
    for          line in program    :    #
        for          instruction    in   line.split():
            try                     :    #
                instructionValue    =    int(instruction)
                instructions        .    append(instructionValue)
            except    ValueError    :    #
                return              instructions
    return          instructions    ;    #
def                pad(row, size    )    :
    if            size > len(row    )    :
        row               += [0]    *    (size - len(row))
def                       update    (    instruction, row):
    pad                     (row    ,    instruction + 1)
    pad                     (row    ,    row[instruction] + 1)
    pad                     (row    ,    row[row[instruction]] + 1)
    row                     [row    [    row[instruction ]]] += 1
def                    do_io(row    )    :
    pad                     (row    ,    4)
    if             row[1] % 2 ==    1    :
        print         (chr(row[3    ]    %256), end="")
def             run(instructions    ,    max_cycles, io):
    row                        =    [    ]
    cycles                     =    0    ;
    while                   True    :    #
        if            max_cycles    !=   None and cycles > max_cycles:
            if                io    :    #
                print        (""    )    ;
            return           row    ;    #
        index           = cycles    %    len(instructions)
        update     (instructions    [    index], row)
        if          index == len    (    instructions) - 1 and io:
            do_io           (row    )    ;
        cycles                +=    1    ;
    return                   row    ;    #
def                        repl(    )    :
    print                           (    "3 Star Programmer REPL")
    instructions               =    [    ]
    row                        =    [    ]
    while                   True    :    #
        try                         :    #
            instructionValue        =    int(input(">>> "))
            instructions            .    append(instructionValue)
            update                  (    instructionValue, row)
            print           (row    )    ;
        except        ValueError    :    #
            return                  ;    #
if        __name__ == '__main__'    :    #
    parser            = argparse    .    ArgumentParser(description="Three Star Programmer interpreter. https://esolangs.org/wiki/Three_Star_Programmer")
    parser         .add_argument    (    "filename", help="Leave empty to use as a REPL. Options have no effect on the REPL.", nargs="?")
    parser         .add_argument    (    "-s", "--max_steps", type=int, help="Limits the number of steps the program takes.")
    parser         .add_argument    (    "-o", "--output", action="store_true", help="Outputs according to the output extension.")
    parser         .add_argument    (    "-p", "--print_tape", action="store_true", help="Prints the memory each step.")
    args                = parser    .    parse_args()
    if                      args    .    filename == None:
        repl                   (    )    ;
    else                            :    #
        with           open(args    .    filename, "r") as f:
            program          = f    .    readlines()
        if       args.print_tape    :    #
            print           (run    (    parse_contents(program), args.max_steps, args.output))
        else                        :    #
            run  (parse_contents    (    program), args.max_steps, args.output)
